--Auther Travis Davis ::    Travisstorma, Eredar, US server.
--Inspired by a couple guildies.
--This my be freely used and ripped apart for others.
--Enjoy

local debug = false

leusaved = { }
leuoptions = { }
leuoptions.pixel = true
LeUlines = { }

local leuhelp = {
	"You can also use /line instead of /leu or /lineemup",
	"/leu x -- Creates a x axis line.",
	"/leu y -- Creates a y axis line.",
	"/leu clear -- Clears all lines.",
	"/leu clear x -- Clears all x plane lines.",
	"/leu clear y -- Clears all y plane lines.",
	"/leu clear <linename> -- Clears the line... /leu clear leu1 -- clears LeU1 line.",
	"/leu move <linename> <%> -- Moves the line to the specified place.. /leu move leu1 33 -- moves line 1 to 33% from either bottom or left side.",
	"/leu save -- Saves frame positions between reload sessions",
	"/leu restore -- Restores saved frame positions",
	"/leu pixel -- toggles showing pixel count"
}

function LeU_OnLoad(self)
	SlashCmdList["LINEEMUP"] = LineemUp_Slash
	SLASH_LINEEMUP1 = "/lineemup"
	SLASH_LINEEMUP2 = "/leu"
	SLASH_LINEEMUP3 = "/line"
	self:RegisterEvent("PLAYER_ENTERING_WORLD")
end

function LineemUp_Slash(msg)
	msg = string.lower(msg)
	if msg == "x" then
		LeU_frame("x")
	elseif msg == "y" then
		LeU_frame("y")
	elseif msg == "clear" then
		LeU_clear()
	elseif msg == "clear x" then
		LeU_clear("x")
	elseif msg == "clear y" then
		LeU_clear("y")
	elseif msg == "dump" then
		LEU_DUMP()
	elseif msg == "save" then
		leu_save()
	elseif msg == "restore" then
		leu_restore()
	elseif msg =="pixel" then
		LeU_pixeltoggle()
	elseif string.sub(msg, 0, 4) == "move" then
		local _, _, _, bar, percent = string.find(msg,"(%w+) (%w+) ([:%d]+)")
		percent = tonumber(percent)
		if bar and percent then
			if percent > 0 and percent < 100.1 then
				if debug then print("Slashhandler bar: " .. bar .. "- commanded to " .. percent .. "%.") end
				LeU_move(bar, percent)
			end
		end
	elseif string.sub(msg, 0, 9) == "clear leu" then
		local _, _,line = string.find(msg,"clear leu(.+)")
		if _G["LeU"..line] then
			_G["LeU"..line]:Hide()
		end
	elseif msg == "" then
		for _, k in ipairs(leuhelp) do
			DEFAULT_CHAT_FRAME:AddMessage(k)
		end
	end
end

function LeU_frame(type, position)
	if not LeUisloaded then
		LeUisloaded = 1
	end
	local n = 1
	local template
	for _ in pairs(LeUlines) do
		n = n + 1
	end
	local framename = "LeU" .. n
	if namess then 
		framename = namess
	end
	if type == "x" then
		template = "LeUHor"
	elseif type == "y" then
		template = "LeUVert"
	end
	local frame = CreateFrame("Frame", framename, UIParent, template)
	if debug then print("Create frame name:" .. framename) end
	_G[framename]:RegisterForDrag("LeftButton")
	_G[framename]:SetScript("OnDragStart", function(self) self:StartMoving() end)
	_G[framename]:SetScript("OnDragStop", function(self) self:StopMovingOrSizing() end)
	_G[framename]:SetScript("OnUpdate", function(self) 
		if GetMouseFocus() == self then
			if type == "y" then
				local x = frame:GetCenter()
				local pos = LeU_round(x / UIParent:GetWidth() *100,2)
				LeUtooltipadd(self:GetName(), x, pos)
			elseif type == "x" then
				local _,y = frame:GetCenter()
				local pos = LeU_round(y / UIParent:GetHeight() *100,2)
				LeUtooltipadd(self:GetName(), y, pos)
			end
		end
	end)
	if debug then print("Show Command: " .. frame:GetName()) end
	frame:Show()
	LeUlines[framename] = type
	if position then 
		LeU_movesave(string.lower(framename), position)
	end
end

function LeU_move(bar,position)
	local point
	position = position / 100
	if debug then print("Position: "..position) end
	local _, _,line = string.find(bar,"leu(.+)")
	if line then
		local line = "LeU"..line
		if _G[line] then
			local axis = LeUlines[line]
			if debug then print("Move axis: "..axis) end
			if axis == "x" then 
				point = floor(UIParent:GetHeight() * position)
				_G[line]:SetPoint("BOTTOM", 0, point)
				if debug then print("Line: ".. line .. ":  Pixel to move to: " ..point) end
			elseif axis == "y" then
				point = floor(UIParent:GetWidth() * position)
				_G[line]:SetPoint("LEFT", point, 0)
				if debug then print("Line: ".. line.. ":   Pixel to move: " ..point) end
			end
		end
	end
end

function LeU_clear(axis)
	if axis then
		for i, k in pairs(LeUlines) do
			if k == axis then
				_G[i]:Hide()
			end
		end
	else
		for i, k in pairs(LeUlines) do
			_G[i]:Hide()
		end
	end
end

function LeU_round(input, places)
	if not places then
		places = 1
	end
	if type(input) == "number" and type(places) == "number" then
		local pow = 1
		for i = 1, ceil(places) do
			pow = pow * 10
		end
		return floor(input * pow + 0.5) / pow
	end
end

function LeUtooltipadd(frame, pix, pos)
	local message 
	if leuoptions.pixel then 
		message = frame .. "\n" .. "Pixel - " .. LeU_round(pix,0) .. "\n" .. "Position - " .. pos .. "%"
	else
		message = frame .. "\n" .. "Position - " .. pos .. "%"
	end
	if LeUtooltip:IsVisible() then
		LeUtooltip:ClearLines()
		LeUtooltip:AddLine(message)
		LeUtooltip:Show()
	else
		LeUtooltip:SetOwner(UIParent, "ANCHOR_CURSOR")
		LeUtooltip:AddLine(message)
		LeUtooltip:Show()
	end
end

function LeU_OnUpdate()
	if LeUisloaded == 1 then
		local frame = GetMouseFocus() and GetMouseFocus():GetName() or "" 
		if frame then
			if string.sub(frame, 1,3) == "LeU" then
				return
			end
		end
		LeUtooltip:Hide()
	end
end

function LEU_DUMP()
	if debug then
		for k, v in pairs(LeUlines) do
			print(k .. "-" .. v)
		end
	end
end

function leu_save()
leusaved = { }
	local pos
	print("Saving frame positions.")
	for k, v in pairs(LeUlines) do
		if _G[k]:IsVisible() then
			if v == "y" then
				local x = _G[k]:GetCenter()
				pos = x
			elseif v == "x" then
				local _,y = _G[k]:GetCenter()
				pos = y
			end
		leusaved[k] = {v, pos}
		end
	end
end

function leu_restore()
	for k, v in pairs(leusaved) do
		LeU_frame(v[1], v[2])
	end
end

function LeU_pixeltoggle()
	if leuoptions.pixel == true then
		leuoptions.pixel = false
		print("Pixel position reporting is now turned off.")
	else
		leuoptions.pixel = true
		print("Pixel position reporting is now turned on.")
	end
end

function LeU_movesave(bar, position)
	local _, _,line = string.find(bar,"leu(.+)")
	if line then
		local line = "LeU"..line
		if _G[line] then
			local axis = LeUlines[line]
			if debug then print("Move axis: "..axis) end
			if axis == "x" then 
				_G[line]:SetPoint("BOTTOM", 0, position)
					if debug then print("Line: ".. line.. ":   Pixel to move: " ..position) end
			elseif axis == "y" then
				_G[line]:SetPoint("LEFT", position, 0)
					if debug then print("Line: ".. line.. ":   Pixel to move: " ..position) end
			end
		end
	end
end

CreateFrame("GameToolTip", "LeUtooltip", UIParent, "GameTooltipTemplate")
LeUtooltip:SetOwner(UIParent, "ANCHOR_CURSOR")